Last Comment Bug 811677 - Turn "Licensing" item into "Legal Information" and make it a sub-menu
: Turn "Licensing" item into "Legal Information" and make it a sub-menu
Status: RESOLVED FIXED
: late-l10n
Product: Firefox OS
Classification: Client Software
Component: Gaia::Settings (show other bugs)
: unspecified
: All All
: P2 normal (vote)
: B2G C2 (20nov-10dec)
Assigned To: Fabien Cazenave [:kaze]
:
Mentors:
Depends on:
Blocks: 812955
  Show dependency treegraph
 
Reported: 2012-11-14 03:03 PST by Gervase Markham [:gerv]
Modified: 2012-12-06 09:58 PST (History)
17 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
+


Attachments
Licensing sub menu wireframe (47.85 KB, image/png)
2012-11-26 17:52 PST, Larissa Co [:lco]
no flags Details
patch (160 bytes, text/html)
2012-12-03 07:02 PST, Michał Budzyński (:michalbe)
fabien: review+
Details
l10n fix (190 bytes, text/html)
2012-12-06 09:44 PST, Fabien Cazenave [:kaze]
stas: review+
Details

Description Gervase Markham [:gerv] 2012-11-14 03:03:36 PST
In the "Device Information" screen there are currently 3 options under "About Firefox OS": 

"About Your Rights"
"About Your Privacy"
"Licensing"

"About Your Rights" and "Licensing" both bring up HTML pages. "About Your Privacy" brings up a list of privacy policies (2 in my build - ours and everything.me) which are links to pages on the web (a browser opens).

We need to change "Licensing" to "Legal Information" and make it a "sub-menu" like "About Your Privacy". The sub-menu needs one entry to start with: "Open Source Licenses", which will link to a locally-shipped HTML page with the content from bug 811325. (Insert a placeholder page for now, perhaps the one currently directly linked to from the "Licensing" button.) In future, I strongly suspect (contradict me if I'm wrong, Jishnu) that this menu will acquire other items e.g. licensing terms for proprietary components, legal agreements for web services the device uses, or legal documents from the carrier. At any rate, I think it's valuable for us and our partners to have the flexibility of adding additional legal documents.

Gerv
Comment 1 Larissa Co [:lco] 2012-11-14 11:03:52 PST
I can create wireframes for this when I get back after Thanksgiving, but no guarantees that we have time to re-implement for v1 since this design has been on the table for a while. Chris Lee, can you help us figure out how to get this in front of the right people?
Comment 2 Gervase Markham [:gerv] 2012-11-14 13:35:31 PST
Does this actually need wireframes? Is the spec above not pretty much sufficient?

Did anyone from the Legal team sign off on the current design at any point?

Gerv
Comment 3 Gervase Markham [:gerv] 2012-11-15 09:24:43 PST
Nominating for blocking-basecamp; we need room for any necessary legal info from us, OEMs and/or carriers. 

Gerv
Comment 4 Jishnu Menon :jishnu 2012-11-15 12:50:42 PST
Hi Larissa - 

I spoke with Gerv - this is pretty important and I think we can fit it in the current UX - will include in my overall comments to you by email and copy Gerv.

Thanks
Jishnu
Comment 5 Gervase Markham [:gerv] 2012-11-16 04:25:33 PST
Even if we decide not to make it a sub-menu, there is some necessary code work here, because currently the licensing information is 3 paragraphs of text defined in the settings.en-US.properties file. I suspect this method will not scale to the 439k of text necessary for the current incarnation of the "about:credits" info.

So given that _some_ work is essential here, this bug should block.

CCing benfrancis, who has mentioned in other bugs the technical approaches we might use to display the licensing file, and Vivien, who seems to own the Settings app (is that right?).

Gerv
Comment 6 Vivien Nicolas (:vingtetun) (:21) - (NOT reading bugmails, needinfo? please) 2012-11-16 06:48:35 PST
(In reply to Gervase Markham [:gerv] from comment #5)
> Even if we decide not to make it a sub-menu, there is some necessary code
> work here, because currently the licensing information is 3 paragraphs of
> text defined in the settings.en-US.properties file. I suspect this method
> will not scale to the 439k of text necessary for the current incarnation of
> the "about:credits" info.
> 
> So given that _some_ work is essential here, this bug should block.
> 
> CCing benfrancis, who has mentioned in other bugs the technical approaches
> we might use to display the licensing file, and Vivien, who seems to own the
> Settings app (is that right?).
> 

Not really. I would say Kaze and some of our friends from Taipei owns it :)

CC'ing them. 


> Gerv
Comment 7 Jishnu Menon :jishnu 2012-11-19 09:21:46 PST
Hi all - where is this? We need to get this into the product somewhere and need your help with where it goes. Doesn't have to be perfect, please give us some options (or one if that's all there is).
Comment 8 Jishnu Menon :jishnu 2012-11-19 09:21:46 PST
Hi all - where is this? We need to get this into the product somewhere and need your help with where it goes. Doesn't have to be perfect, please give us some options (or one if that's all there is).
Comment 9 Gervase Markham [:gerv] 2012-11-21 02:05:40 PST
Our legal advice says that the "open source licensing" content needs to ship on the device and be permanently available.

Jishnu has a mockup roughly like comment 0, which I hope he will attach. (I still think we should use "Legal Information" rather than "Licensing" though.)

Gerv
Comment 10 Alex Keybl [:akeybl] 2012-11-21 06:11:34 PST
Marking for C2, given this meets the criteria of known P1/P2 blocking-basecamp+ bugs at the end of C1.
Comment 11 :Margaret Leibovic 2012-11-21 10:28:11 PST
Cc'ing stas because this will involve late string changes. Looking at bug bug 811325, this actually looks like a ton of text that would need to be translated :/
Comment 12 Gervase Markham [:gerv] 2012-11-21 13:26:55 PST
Margaret: there's no need to translate the big license texts, don't worry :-) If the header (5 sentences or so) could be translated, that would be great, but perhaps it's not essential for version 1. (It also depends on whether we have the technology.)

Gerv
Comment 13 :Margaret Leibovic 2012-11-21 13:41:28 PST
Okay, it's good to know that we don't need to translate the text from bug 811325 :)

However, we would still need to add strings for "Legal Information" and "Open Source Licenses", if I understand comment 0 correctly.
Comment 14 Gervase Markham [:gerv] 2012-11-21 13:55:33 PST
Yes, that's true. And, ideally, the 2 paragraphs at the top of 
https://bug811325.bugzilla.mozilla.org/attachment.cgi?id=683578

Gerv
Comment 15 Staś Małolepszy :stas 2012-11-23 02:24:31 PST
I didn't mean to change the assignee.
Comment 16 Larissa Co [:lco] 2012-11-26 17:52:32 PST
Created attachment 685427 [details]
Licensing sub menu wireframe

I looked at this bug again, and don't really like the idea of allowing the user to go click on a link that goes to a one-link menu that goes to the licensing page. See the attachment here.

For v1, I would rather rename the link in the Device Settings Page to "Open Source Licenses" and go directly to the URL from there. In the future, we can do what Gerv's suggesting, but I think it's not a good use of the user's time to have a single-link page, even though it's more scalable for later.
Comment 17 Larissa Co [:lco] 2012-11-26 18:28:08 PST
Here are updated proposed wireframes (v7 DRAFT): https://people.mozilla.com/~lco/Legal_and_Privacy_B2G/

See pp 12 & 15 for the wireframes relevant to this bug (assuming that we don't create an interim page from a Legal Information link that contains a link to the Open Source Licenses. I can always edit this page if people are strongly opposed to it.)
Comment 18 Gervase Markham [:gerv] 2012-11-27 01:05:53 PST
Larissa: having the "single-link page" is not "for later" in the sense of B2G version 2 or version 3, it's because we think there's at least a reasonable likelihood that OEMs or carrier partners will want to put their own legal agreements in the phone, and we need a place to put them. If we make the button directly say "Open Source Licenses", and then Telefonica come forward and say "we need to put our User Agreement on this phone we are about to ship, where do we put it?" then we are a bit stuck.

Ideally, the patch for this bug would mean the list of links was generated by looking for all the files in a directory, so they just had to drop in a file to make it work. That might be a bit optimistic, but I think that if we don't at least provide a place for such agreements, there's a significant risk we'll have to do late engineering (and even later l10n) to put one in.

Gerv
Comment 19 Jishnu Menon :jishnu 2012-11-27 08:02:28 PST
(In reply to Larissa Co from comment #17)

(In reply to Gervase Markham [:gerv] from comment #18)

Hi Gerv and Larissa,

On page 12, can we please change "Open Source Licenses" to "Licensing"? There may be non-open licenses our partners would like to include.

On page 15, the content should look like "Your Privacy", but instead say something like this:

Title: "Licensing"

"Mozilla"

"+[Firefox OS Open Source Notices]" [link to a new page that is a locally hosted version of Gerv's notices file with a back button]

"Others"

"+Partner 1 licenses"

"+Partner 2 licenses"

etc.
Comment 20 Jishnu Menon :jishnu 2012-11-27 08:11:45 PST
(In reply to Larissa Co from comment #17)
> Here are updated proposed wireframes (v7 DRAFT):
> https://people.mozilla.com/~lco/Legal_and_Privacy_B2G/
> 
> See pp 12 & 15 for the wireframes relevant to this bug (assuming that we
> don't create an interim page from a Legal Information link that contains a
> link to the Open Source Licenses. I can always edit this page if people are
> strongly opposed to it.)

Just saw your mock on page 18 - we could go with "Legal" or "Legal Information" with the title IMO, but looks like you got the flow right per my last message.
Comment 21 Larissa Co [:lco] 2012-11-27 10:21:28 PST
(In reply to Gervase Markham [:gerv] from comment #18)
> Larissa: having the "single-link page" is not "for later" in the sense of
> B2G version 2 or version 3, it's because we think there's at least a
> reasonable likelihood that OEMs or carrier partners will want to put their
> own legal agreements in the phone, and we need a place to put them. If we
> make the button directly say "Open Source Licenses", and then Telefonica
> come forward and say "we need to put our User Agreement on this phone we are
> about to ship, where do we put it?" then we are a bit stuck.

Ok, thanks for clarifying. I'll update my draft with the wireframes for a list of legal documents. I'll also update the text to what Jishnu has asked for.
Comment 22 Larissa Co [:lco] 2012-11-27 14:03:04 PST
I've updated the wireframes with the comments here, the https://people.mozilla.com/~lco/Legal_and_Privacy_B2G/ link is still good though.
Comment 23 Gervase Markham [:gerv] 2012-11-28 02:29:53 PST
lco: wireframes look good. You can find the text for About Your Rights in bug 811678, if that helps. The info for the open source licenses page is only in bug 811325; there's none of it in this bug. Also, p.12 suggests "About:Rights" is a URL; it's not, it's the page on p.14.

Gerv
Comment 24 Larissa Co [:lco] 2012-11-28 11:12:43 PST
(In reply to Gervase Markham [:gerv] from comment #23)
> Also, p.12 suggests
> "About:Rights" is a URL; it's not, it's the page on p.14.
>
Oh right, I changed it on pg. 3 but forgot to change it on pg. 12. thanks for the catch.

I'll add the non-draft version soon ;-)
Comment 25 Dylan Oliver [:doliver] 2012-11-30 16:51:56 PST
Michal, do you have time to get this done for C2?
Comment 26 Vivien Nicolas (:vingtetun) (:21) - (NOT reading bugmails, needinfo? please) 2012-12-02 07:57:29 PST
(In reply to Gervase Markham [:gerv] from comment #23)
> lco: wireframes look good. You can find the text for About Your Rights in
> bug 811678, if that helps. The info for the open source licenses page is
> only in bug 811325; there's none of it in this bug. 

That helps. thanks :)

> Also, p.12 suggests
> "About:Rights" is a URL; it's not, it's the page on p.14.
> 

Sounds a different bug right?
Comment 27 Vivien Nicolas (:vingtetun) (:21) - (NOT reading bugmails, needinfo? please) 2012-12-02 07:58:03 PST
(In reply to Dylan Oliver [:doliver] from comment #25)
> Michal, do you have time to get this done for C2?

I would see with him tomorrow. Otherwise it can be handle by someone else in the Paris office.
Comment 28 Michał Budzyński (:michalbe) 2012-12-02 13:14:53 PST
I'm working on it, should finish today/tomorrow.
Comment 29 Vivien Nicolas (:vingtetun) (:21) - (NOT reading bugmails, needinfo? please) 2012-12-03 02:13:08 PST
(In reply to Michal Budzynski (:michalbe) from comment #28)
> I'm working on it, should finish today/tomorrow.

Does anything is missing for you to finish it today?
Comment 30 Michał Budzyński (:michalbe) 2012-12-03 02:37:08 PST
I don't think so.
Comment 31 Michał Budzyński (:michalbe) 2012-12-03 07:02:29 PST
Created attachment 687752 [details]
patch
Comment 32 Fabien Cazenave [:kaze] 2012-12-03 11:00:53 PST
Comment on attachment 687752 [details]
patch

r=me, but please fix the indentation. Thanks for your patch!
Comment 33 Michał Budzyński (:michalbe) 2012-12-03 11:09:30 PST
fixed
Comment 34 Fabien Cazenave [:kaze] 2012-12-03 11:27:18 PST
https://github.com/mozilla-b2g/gaia/commit/4deef6a0049c85cd3ba6421515c9085c23ec71ef

Staś, I'm afraid we have late l10n changes on this one as well. :-(
Comment 35 Staś Małolepszy :stas 2012-12-06 09:30:57 PST
Dang, I didn't see this one in time.  'about-licensing" id should have changed.  Can you please fix it?
Comment 36 Fabien Cazenave [:kaze] 2012-12-06 09:44:38 PST
Created attachment 689246 [details]
l10n fix

Ooops, good catch! Sorry for that, here’s a quick patch.
Comment 37 Staś Małolepszy :stas 2012-12-06 09:56:57 PST
Comment on attachment 689246 [details]
l10n fix

r=me, that was super-quick <3
Comment 38 Vivien Nicolas (:vingtetun) (:21) - (NOT reading bugmails, needinfo? please) 2012-12-06 09:58:05 PST
https://github.com/mozilla-b2g/gaia/commit/e8b40b2aa7645c92b5a13698876376842b205152

Note You need to log in before you can comment on or make changes to this bug.